/*
** Copyright (C) 1998-2005 George Tzanetakis <gtzan@cs.uvic.ca>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef MARSYAS_BASEAUDIOSINK_H
#define MARSYAS_BASEAUDIOSINK_H

#include "MarSystem.h"

namespace Marsyas
{
/**
   \class BaseAudioSink
	\ingroup Internal
   \brief Interface for real-time audio sources
   
   Abstract base class used as interface for real-time audio sources.
*/


class BaseAudioSink:public MarSystem
{
protected:
  short *sdata_;
  
public:
	BaseAudioSink(std::string name);
  virtual ~BaseAudioSink();
  virtual void myProcess(realvec& in, realvec& out) = 0;
};

}//namespace Marsyas

#endif


	
