/*
** Copyright (C) 1998-2005 George Tzanetakis <gtzan@cs.uvic.ca>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#ifndef MARSYAS_FILENAME_H
#define MARSYAS_FILENAME_H

#include <vector>
#include <string>
#include "DLLDefines.h"
#include "common_header.h"

namespace Marsyas
{
/** 
    \class FileName
	\ingroup Notmar
    \brief Various utilities

    FileName is a class bundling together various rather 
unrelated convenience utilities related to filenames. 
*/


class marsyas_EXPORT FileName
{
private:
  std::string filename_;

  size_t getLastSlashPos ();
  void removeLastSlash ();
  
public:
  FileName();
  FileName(std::string filename);
  ~FileName();  
  std::string fullname();			// full filename (path+file)
  std::string name();			// returns just the file (no path)
  std::string nameNoExt(); // returns just the file (no path, no ext)
  std::string path();	// returns the filename path 
  std::string ext();				// returns the filename extension
  mrs_bool    isDir (); // true if it is a directory, not a file
  std::vector<mrs_string> getFilesInDir (mrs_string wildcard); //get a list of files in the directory
};

}//namespace Marsyas

#endif
