/*
** Copyright (C) 1998-2006 George Tzanetakis <gtzan@cs.uvic.ca>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef MARSYAS_MEDDISHAIRCELL_H
#define MARSYAS_MEDDISHAIRCELL_H

#include "MarSystem.h"

namespace Marsyas
{
/** 
    \class MeddisHairCell
    \ingroup Analysis
    \brief MeddisHairCell for auditory models 

    Directed port from the Auditory toolbox by Malcolm Slaney 
*/


class MeddisHairCell: public MarSystem
{
private: 
  void addControls();
	void myUpdate(MarControlPtr sender);
  
  mrs_natural numChannels;
  
  //parameters
  mrs_real M;
  mrs_real A;
  mrs_real B;
  mrs_real g;
  mrs_real y;
  mrs_real l;
  mrs_real r;
  mrs_real x;
  mrs_real h;
  
  //internal constants
  mrs_real dt;
  mrs_real gdt;
  mrs_real ydt;
  mrs_real ldt;
  mrs_real rdt;
  mrs_real xdt;
  
  //initial values
  mrs_real kt;
  mrs_real spont;
  
  realvec c;
  realvec q;
  realvec w;
  
public:
  MeddisHairCell(std::string name);
  ~MeddisHairCell();
  
  MarSystem* clone() const;

	void myProcess(realvec& in, realvec& out); 
};

}//namespace Marsyas

#endif 

